// pages/bind/index.js
const app = getApp()
Page({

  /**
   * 页面的初始数据
   */
  data: {
    name: "",
    mobile: "",
    userInfo: {},
  },

  bindName(e) {
    this.setData({
      name: e.detail.value
    })
  },
  bindMobile(e) {
    this.setData({
      mobile: e.detail.value
    })
  },

  async toBind() {
    if (!app.globalData.openid) {
      wx.showToast({
        title: '缺少用户信息,请重新进入',
        icon: 'none'
      })
    }
    const obj = { name: this.data.name, mobile: this.data.mobile, appopenid: app.globalData.openid };
    wx.request({
      url: app.globalData.contentpath + 'api/train/user/appbind',
      header: {//请求头
        "Content-Type": "application/json"
      },
      data: JSON.stringify(obj),
      method: 'POST',
      dataType: 'json',
      success: (res) => {
        const r = res.data;
        if (r.errcode == '0') {
          wx.showToast({
            title: '绑定成功',
            icon: 'success',
            duration: 3000
          })
          app.globalData.userInfo = r.data;
          const userInfo = app.globalData.userInfo;
          if (userInfo) {
            wx.navigateTo({
              url: '/pages/index/index',
            })
          }
        } else {
          wx.showToast({
            title: r.errmsg || "绑定失败",
            icon: 'none',
            duration: 3000
          })
        }
      },
      fail: (res) => {
        console.log(res);

      }
    })

  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {
  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  }
})